//#exemplo tempo.c 
//Tarefa 3: Cada nodo mantém localmente o vetor State[0..N-1], e atualiza as entradas correspondentes ao testar.
#include <stdio.h>
#include <stdlib.h>
#include "smpl.h"

/*eventos*/
#define test 1
#define fault 2
#define repair 3

/*descritor do nodo*/
typedef struct {
	int id; /*identidificador de facility*/
	int* state; // identificador de status
/*variaveis sao declaradas aqui*/
}tnodo;

tnodo *nodo;

main (int argc, char *argv[]){
	static int n,
		   token,
		   event,
		   r,i,j;

	static char
		fa_name[5];
	if (argc !=2){
		puts("use correto: tempo<num_nodos>");
	exit(1);
}

n = atoi (argv[1]);


smpl(0,"um exemplo de simulação");
reset();
stream(i);

/*inicialização*/
nodo= (tnodo*) malloc (sizeof (tnodo)*n);
for (i=0; i < n; i++){
	memset(fa_name, '\0', 5);
	sprintf(fa_name, "%d", i);
	nodo[i].id=facility(fa_name,1);
	nodo[i].state = (int*) malloc (sizeof (int) *n); //aloca espaco pro vetor dinamico
	for (j=0; j < n; j++)     //laco para completar o vetor come stado indeterminado
	    if (i==j)  nodo[i].state[j] = 0;  //seu estado 
	    else nodo[i].state[j] = -1;  //estado indeterminado
}
  

/*escalonamento inicial dos eventos*/
for (i=0; i < n; i++)
	schedule(test, 30.0, i);
schedule(fault, 50.0, 2);
schedule(repair, 80.0, 2);

/*dispara o tempo de simulacao*/
while (time() < 100.0) {
	cause (&event,&token);
	switch (event){
		case test:	
			if(status (nodo[token].id)!=0) 
			  break;
			int prox = token; //
			do {
			    prox = (prox+1)%n; 
			    if (status (nodo[prox].id)==0)
			      nodo[token].state[prox] = 0; 
			    else
			      nodo[token].state[prox] = 1; //estado falho
			    printf("o nodo %d vai testar o nodo %d no tempo %5.1f", token, prox, time());
			     			     
			      /*IMPRIME O VETOR */
			        printf("\tvetor =[");
	for(i=0; i<n; i++){
			  
			    if(nodo[token].state[i] == -1)
			      printf(" * "); /*indefinido*/
			    else if(nodo[token].state[i] == 1)
			      printf(" X "); /*falhou*/
			    else
			      printf(" %d ",nodo[token].state[i]);/*Fault-free=0*/
                   }
               printf("]\n");
			     
			} while (status (nodo[prox].id) !=0);
			schedule(test,30.0, token);
			break;
		
		case fault:
			r=request(nodo[token].id,token,0);
			if (r!=0){
			    puts("nao foi possivel falhar");
			    exit(1);
			}
			 
			    printf("o nodo %d falhou no tempo %5.1f\n", token, time());
			    nodo[token].state[token+1] == 1; 
			    break;
			    
		case repair:
		    printf("o nodo %d recuperou no tempo %5.1f\n", token,time());
		    release(nodo[token].id,token);
		    schedule(test,30.0,token);
		    break;
	}}}
			    